User account creation filtered due to spam.

Bug 16489 - [3.3/3.4/4.0 Regression] G++ incorrectly rejects use of a null constant integral expression as a null constant pointer
Summary: [3.3/3.4/4.0 Regression] G++ incorrectly rejects use of a null constant integ...
Status: RESOLVED FIXED
Alias: None
Product: gcc
Classification: Unclassified
Component: c++ (show other bugs)
Version: 3.4.0
: P2 critical
Target Milestone: 3.4.2
Assignee: Mark Mitchell
URL:
Keywords: rejects-valid
Depends on:
Blocks:
 
Reported: 2004-07-12 07:23 UTC by Gabriel Dos Reis
Modified: 2004-10-30 21:10 UTC (History)
1 user (show)

See Also:
Host: Plateform independent
Target:
Build:
Known to work: 3.0.4 3.4.2 4.0.0
Known to fail: 3.2.3 3.2.2 3.3.3 3.4.0
Last reconfirmed: 2004-07-12 07:32:04


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Gabriel Dos Reis 2004-07-12 07:23:06 UTC
Consider

    const int NULL = 0;
    int main() { double* p = NULL; }

G++ incorrectly rejects the above.  This regression is also present
in GCC-3.3.x, in direct violation of the C++ standard.
Comment 1 Andrew Pinski 2004-07-12 07:32:04 UTC
Confirmed.  Phil's regression hunter <http://www.devphil.com/~reghunt/> is down during the early 
EST morning hours :(.
Comment 2 Andrew Pinski 2004-07-12 14:06:04 UTC
Here is the result from Phil's regression hunter: Search converges between 2002-11-30-trunk (#150) 
and 2002-12-02-trunk (#151).
Comment 3 Andrew Pinski 2004-07-26 14:46:02 UTC
Note unlike most other constant integral expression 0 is special IIRC.
Comment 4 Gabriel Dos Reis 2004-07-27 10:57:37 UTC
Subject: Re:  [3.3/3.4/3.5 Regression] G++ incorrectly rejects use of a null constant integral expression as a null constant pointer

"pinskia at gcc dot gnu dot org" <gcc-bugzilla@gcc.gnu.org> writes:

| Note unlike most other constant integral expression 0 is special IIRC.

I do not understand what you meant to imply...

-- Gaby
Comment 5 Mark Mitchell 2004-08-01 21:24:49 UTC
Working on a fix.
Comment 6 CVS Commits 2004-08-02 01:56:41 UTC
Subject: Bug 16489

CVSROOT:	/cvs/gcc
Module name:	gcc
Branch: 	gcc-3_4-branch
Changes by:	mmitchel@gcc.gnu.org	2004-08-02 01:56:33

Modified files:
	gcc/cp         : ChangeLog call.c cp-tree.h decl.c pt.c 
	                 semantics.c typeck.c 
	gcc/testsuite  : ChangeLog 
Added files:
	gcc/testsuite/g++.dg/inherit: ptrmem2.C 
	gcc/testsuite/g++.dg/init: null1.C 
	gcc/testsuite/g++.dg/parse: namespace10.C 

Log message:
	PR c++/16338
	* cp-tree.h (DECL_INTEGRAL_CONSTANT_VAR_P): New macro.
	* call.c (null_ptr_cst_p): Handle variables with constant
	initializers.
	* pt.c (convert_nontype_argument): Use
	DECL_INTEGRAL_CONSTANT_VAR_P.
	* semantics.c (finish_id_expression): Likewise.
	
	PR c++~/16489
	* decl.c (duplicate_decls): Reject duplicate namespace
	declarations.
	
	PR c++/16810
	* typeck.c (build_ptrmemfunc): Loosen assertion.
	
	PR c++/16338
	* g++.dg/init/null1.C: New test.
	* g++.dg/tc1/dr76.C: Adjust error marker.
	
	PR c++/16489
	* g++.dg/parse/namespace10.C: New test.
	
	PR c++/16810
	* g++.dg/inherit/ptrmem2.C: New test.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.3892.2.136&r2=1.3892.2.137
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/call.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.452.2.19&r2=1.452.2.20
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cp-tree.h.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.946.4.14&r2=1.946.4.15
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/decl.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.1174.2.21&r2=1.1174.2.22
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/pt.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.816.2.34&r2=1.816.2.35
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/semantics.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.381.4.11&r2=1.381.4.12
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/typeck.c.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.519.2.21&r2=1.519.2.22
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=1.3389.2.238&r2=1.3389.2.239
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/ptrmem2.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/init/null1.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/parse/namespace10.C.diff?cvsroot=gcc&only_with_tag=gcc-3_4-branch&r1=NONE&r2=1.1.2.1

Comment 7 CVS Commits 2004-08-02 01:58:56 UTC
Subject: Bug 16489

CVSROOT:	/cvs/gcc
Module name:	gcc
Changes by:	mmitchel@gcc.gnu.org	2004-08-02 01:58:52

Modified files:
	gcc/cp         : ChangeLog call.c cp-tree.h decl.c pt.c 
	                 semantics.c typeck.c 
	gcc/testsuite  : ChangeLog 
	gcc/testsuite/g++.dg/tc1: dr76.C 
Added files:
	gcc/testsuite/g++.dg/inherit: ptrmem2.C 
	gcc/testsuite/g++.dg/init: null1.C 
	gcc/testsuite/g++.dg/parse: namespace10.C 

Log message:
	PR c++/16338
	* cp-tree.h (DECL_INTEGRAL_CONSTANT_VAR_P): New macro.
	* call.c (null_ptr_cst_p): Handle variables with constant
	initializers.
	* pt.c (convert_nontype_argument): Use
	DECL_INTEGRAL_CONSTANT_VAR_P.
	* semantics.c (finish_id_expression): Likewise.
	
	PR c++~/16489
	* decl.c (duplicate_decls): Reject duplicate namespace
	declarations.
	
	PR c++/16810
	* typeck.c (build_ptrmemfunc): Loosen assertion.
	
	PR c++/16338
	* g++.dg/init/null1.C: New test.
	* g++.dg/tc1/dr76.C: Adjust error marker.
	
	PR c++/16489
	* g++.dg/parse/namespace10.C: New test.
	
	PR c++/16810
	* g++.dg/inherit/ptrmem2.C: New test.

Patches:
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/ChangeLog.diff?cvsroot=gcc&r1=1.4254&r2=1.4255
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/call.c.diff?cvsroot=gcc&r1=1.496&r2=1.497
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/cp-tree.h.diff?cvsroot=gcc&r1=1.1026&r2=1.1027
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/decl.c.diff?cvsroot=gcc&r1=1.1265&r2=1.1266
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/pt.c.diff?cvsroot=gcc&r1=1.898&r2=1.899
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/semantics.c.diff?cvsroot=gcc&r1=1.420&r2=1.421
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/cp/typeck.c.diff?cvsroot=gcc&r1=1.565&r2=1.566
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/ChangeLog.diff?cvsroot=gcc&r1=1.4079&r2=1.4080
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/inherit/ptrmem2.C.diff?cvsroot=gcc&r1=1.1&r2=1.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/init/null1.C.diff?cvsroot=gcc&r1=1.1&r2=1.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/parse/namespace10.C.diff?cvsroot=gcc&r1=1.1&r2=1.2
http://gcc.gnu.org/cgi-bin/cvsweb.cgi/gcc/gcc/testsuite/g++.dg/tc1/dr76.C.diff?cvsroot=gcc&r1=1.2&r2=1.3

Comment 8 Mark Mitchell 2004-08-02 02:01:11 UTC
Fixed in GCC 3.4.2 and GCC 3.5.